Package com.smartgwt.client.util.workflow

# Class ComponentTask

java.lang.Object
com.smartgwt.client.core.BaseClass
com.smartgwt.client.util.workflow.ProcessElement
com.smartgwt.client.util.workflow.Task
com.smartgwt.client.util.workflow.ComponentTask

All Implemented Interfaces:
  `HasHandlers`

Direct Known Subclasses:
  `AddScreenTask`, `FetchRelatedDataTask`, `FormClearValuesTask`, `FormDisableFieldTask`, `FormEditNewRecordTask`, `FormEditSelectedTask`, `FormResetValuesTask`, `FormSaveDataTask`, `FormSetFieldValueTask`, `FormSetValuesTask`, `FormValidateValuesTask`, `GetPropertiesTask`, `GridEditRecordTask`, `GridExportClientDataTask`, `GridExportDataTask`, `GridFetchDataTask`, `GridRemoveSelectedDataTask`, `GridSaveAllEditsTask`, `GridSelectRecordsTask`, `GridSetEditValueTask`, `GridTransferDataTask`, `GridViewSelectedDataTask`, `NavigateSplitPaneTask`, `PrintCanvasTask`, `SetPropertiesTask`, `SetScreenDataTask`, `SetTitleTask`, `ShowComponentTask`, `ShowHideTask`, `ShowNextToComponentTask`

public class ComponentTask extends Task
Base class for tasks that target SmartGWT UI-specific operations.

Note: This task is not for direct use - use one of the subclasses instead.

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.core.BaseClass

  `config, configOnly, factoryCreated, factoryProperties, id, scClassName`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ComponentTask()`
  `ComponentTask(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `JavaScriptObject`
  `create()`
  `String`
  `getComponentBaseClass()`
  Base class of components that this task targets.
  `String[]`
  `getComponentBaseClassAsStringArray()`
  Base class of components that this task targets.
  `String`
  `getComponentId()`
  ID of component targeted by this task.
  `Boolean`
  `getComponentRequiresDataSource()`
  Must target components of this task have a DataSource?
  `static ComponentTask`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `String`
  `getTargetBaseClass()`
  Base class of components and any required or optional scope that this task targets.
  `String[]`
  `getTargetBaseClassAsStringArray()`
  Base class of components and any required or optional scope that this task targets.
  `void`
  `getTargetComponent(Process process)`
  Returns the actual component specified by `componentId` for this task.
  `void`
  `getTargetComponent(Process process, Boolean skipValidation)`
  Returns the actual component specified by `componentId` for this task.
  `String`
  `getUnsupportedComponentMessage()`
  The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.
  `ComponentTask`
  `setComponentBaseClass(String componentBaseClass)`
  Base class of components that this task targets.
  `ComponentTask`
  `setComponentBaseClass(String... componentBaseClass)`
  Base class of components that this task targets.
  `ComponentTask`
  `setComponentId(String componentId)`
  ID of component targeted by this task.
  `ComponentTask`
  `setComponentRequiresDataSource(Boolean componentRequiresDataSource)`
  Must target components of this task have a DataSource?
  `ComponentTask`
  `setTargetBaseClass(String targetBaseClass)`
  Base class of components and any required or optional scope that this task targets.
  `ComponentTask`
  `setTargetBaseClass(String... targetBaseClass)`
  Base class of components and any required or optional scope that this task targets.
  `ComponentTask`
  `setUnsupportedComponentMessage(String unsupportedComponentMessage)`
  The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.

  ### Methods inherited from class com.smartgwt.client.util.workflow.Task

  `getExpressionValue, getInputFieldList, getInputRecord, getInputs, getInputsAsString, getInputsAsStringArray, getOutputExpression, getOutputField, getOutputFieldList, getState, getStrictPaths, setInputFieldList, setInputs, setInputs, setInputs, setOutput, setOutputExpression, setOutputField, setOutputFieldList, setState, setStrictPaths`

  ### Methods inherited from class com.smartgwt.client.util.workflow.ProcessElement

  `completeElement, convertToJavaScriptArray, executeElement, getBindOutput, getClassDescription, getComponentReferences, getCurrentProcess, getDescription, getDynamicValue, getEditorType, getElementDescription, getForceSingle, getID, getInvalidTaskMessage, getJsObj, getMockMode, getNextElement, getOrCreateJsObj, getPassThruOutput, getProcessElements, getSupportsMultipleInputRecords, getTextFormulaValue, getTypeTitle, getUndefinedComponentMessage, getUnresolvedComponentMessage, getWaitDuration, getWaitFor, getWaitLocator, isCreated, isValid, objectReferencesLastTaskOutput, onInit, reset, setAttribute, setBindOutput, setClassDescription, setCurrentProcess, setDescription, setEditorType, setForceSingle, setID, setJavaScriptObject, setMockMode, setNextElement, setPassThruOutput, setSupportsMultipleInputRecords, setTypeTitle, setUndefinedComponentMessage, setUnresolvedComponentMessage, setWaitDuration, setWaitFor, setWaitLocator, updateGlobalIDInCriteria, updateGlobalIDInTextFormula, updateGlobalIDInValueProperty, updateGlobalIDInValues, updateGlobalIDReferences, updateLastElementBindingReferences, updateLastElementInCriteria, updateLastElementInValueProperty, updateLastElementInValues`

  ### Methods inherited from class com.smartgwt.client.core.BaseClass

  `addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, asSGWTComponent, clearDynamicProperty, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getRef, getRuleScope, getScClassName, getTestInstance, hasAutoAssignedID, hasDynamicProperty, internalSetID, internalSetID, isConfigOnly, isFactoryCreated, onBind, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setFactoryCreated, setProperty, setProperty, setProperty, setProperty, setRuleScope, setScClassName`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ComponentTask

    public ComponentTask()

  - ### ComponentTask

    public ComponentTask(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static ComponentTask getOrCreateRef(JavaScriptObject jsObj)

  - ### create

    public JavaScriptObject create()
    Overrides:
      `create` in class `Task`

  - ### setComponentBaseClass

    public ComponentTask setComponentBaseClass(String componentBaseClass) throws IllegalStateException
    Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
    Parameters:
      `componentBaseClass` - New componentBaseClass value. Default value is null
    Returns:
      `ComponentTask` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the underlying component has been created

  - ### getComponentBaseClass

    public String getComponentBaseClass()
    Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
    Returns:
      Current componentBaseClass value. Default value is null

  - ### setComponentBaseClass

    public ComponentTask setComponentBaseClass(String... componentBaseClass) throws IllegalStateException
    Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
    Parameters:
      `componentBaseClass` - New componentBaseClass value. Default value is null
    Returns:
      `ComponentTask` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the underlying component has been created

  - ### getComponentBaseClassAsStringArray

    public String[] getComponentBaseClassAsStringArray()
    Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
    Returns:
      Current componentBaseClass value. Default value is null

  - ### setComponentId

    public ComponentTask setComponentId(String componentId) throws IllegalStateException
    ID of component targeted by this task.
    Parameters:
      `componentId` - New componentId value. Default value is null
    Returns:
      `ComponentTask` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the underlying component has been created
    See Also:
      - `GlobalId`

  - ### getComponentId

    public String getComponentId()
    ID of component targeted by this task.
    Returns:
      Current componentId value. Default value is null
    See Also:
      - `GlobalId`

  - ### setComponentRequiresDataSource

    public ComponentTask setComponentRequiresDataSource(Boolean componentRequiresDataSource) throws IllegalStateException
    Must target components of this task have a DataSource?
    Parameters:
      `componentRequiresDataSource` - New componentRequiresDataSource value. Default value is null
    Returns:
      `ComponentTask` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the underlying component has been created

  - ### getComponentRequiresDataSource

    public Boolean getComponentRequiresDataSource()
    Must target components of this task have a DataSource?
    Returns:
      Current componentRequiresDataSource value. Default value is null

  - ### setTargetBaseClass

    public ComponentTask setTargetBaseClass(String targetBaseClass) throws IllegalStateException
    Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

    This can be used by an editor to limit or verify the user's selection.

    Parameters:
      `targetBaseClass` - New targetBaseClass value. Default value is null
    Returns:
      `ComponentTask` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the underlying component has been created

  - ### getTargetBaseClass

    public String getTargetBaseClass()
    Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

    This can be used by an editor to limit or verify the user's selection.

    Returns:
      Current targetBaseClass value. Default value is null

  - ### setTargetBaseClass

    public ComponentTask setTargetBaseClass(String... targetBaseClass) throws IllegalStateException
    Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

    This can be used by an editor to limit or verify the user's selection.

    Parameters:
      `targetBaseClass` - New targetBaseClass value. Default value is null
    Returns:
      `ComponentTask` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the underlying component has been created

  - ### getTargetBaseClassAsStringArray

    public String[] getTargetBaseClassAsStringArray()
    Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

    This can be used by an editor to limit or verify the user's selection.

    Returns:
      Current targetBaseClass value. Default value is null

  - ### setUnsupportedComponentMessage

    public ComponentTask setUnsupportedComponentMessage(String unsupportedComponentMessage) throws IllegalStateException
    The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.
    Parameters:
      `unsupportedComponentMessage` - New unsupportedComponentMessage value. Default value is "${propertyName} '${id}' is not a supported type for this task"
    Returns:
      `ComponentTask` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the underlying component has been created

  - ### getUnsupportedComponentMessage

    public String getUnsupportedComponentMessage()
    The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.
    Returns:
      Current unsupportedComponentMessage value. Default value is "${propertyName} '${id}' is not a supported type for this task"

  - ### getTargetComponent

    public void getTargetComponent(Process process)
    Returns the actual component specified by `componentId` for this task. Unless `skipValidation` is true, the component type is validated against `componentBaseClass` and only returned if it matches. Null is returned otherwise.
    Parameters:
      `process` - the process that is handling the workflow

  - ### getTargetComponent

    public void getTargetComponent(Process process, Boolean skipValidation)
    Returns the actual component specified by `componentId` for this task. Unless `skipValidation` is true, the component type is validated against `componentBaseClass` and only returned if it matches. Null is returned otherwise.
    Parameters:
      `process` - the process that is handling the workflow
      `skipValidation` - skip validation against componentBaseClass?